%{
 /*Gramatyka konwertera rwna Boolowskich na posta odwrotnej notacji polskiej
   Pawe Muszyski 2000

   Zaoenia:
   gramatyka zgodna z gramtyk jzyka VHDL dotyczc rwna boolowskich
   tablice indeksowane tylko liczb cakowit, lub identyfikatorem lub t-1
 */

/*
#define MSDOS dla pracy w MSDOS
#define UNIX dla pracy w UNIX
*/
#define MSDOS
#include <stdio.h>
#include <malloc.h>
#ifdef MSDOS
#include <dos.h>                //do czasu wykonania
#endif
#ifdef UNIX
#include <sys/time.h>
#include <unistd.h>
#endif
#define MAXID 30000             //maksymalny rozmiar identyfikatora (w bajtach),
                                //nie moze przekroczyc maksymalnego alokowalnego
                                //ciaglego bloku pamieci (64K w DOS)
#define BUFFERSIZE 32767	//rozmiar bufora dyskowego (max. 32767 w MSDOS)
FILE *outf;                     //plik wyjsciowy
char *txt;                      //bufor na skadanie dugich ID i komentarzy
int linenum=1;			//globalny nr linii
#ifdef MSDOS
#include "lexyy.c"
#endif
#ifdef UNIX
#include "lex.yy.c"
#endif
%}

%token ID

%left OR
%left AND
%left NOT
%token EQ
%token COMMENT
%token '('
%token ')'
%token INT_EXPR
%token SEMICOL
%token '{'
%token '}'



%%
input:	/*empty*/
	|input instr
;

instr:	COMMENT    {getfromlist();}
	|ident EQ {fprintf(outf,"=");}expr SEMICOL {fprintf(outf,";\n");}
	|klamra
;
klamra:	'{'	{fprintf(outf,"{\n");}
	|'}'	{fprintf(outf,"}\n");}
;

expr:	expr OR expr {fprintf(outf,"|");}
	|expr AND  expr {fprintf(outf,"&");}
	|NOT expr {fprintf(outf,"!");}
	|'(' expr ')'
	|ident
	|INT_EXPR {getfromlist();}
;

ident:	ID {getfromlist();}     /*IDENTYFIKATOR RAZEM Z CALYMI INDEKSAMI */

;

%%

int yyerror(char * s)
{
  fprintf(stderr,"Parse error in line : %d",linenum);
  return 1;
}
int main(int argc, char**argv)
{
#ifdef MSDOS
  struct time czas;
  gettime(&czas);
  printf("Start obliczen: %i : %i : %i : %i \n",czas.ti_hour, czas.ti_min, czas.ti_sec,czas.ti_hund);
#endif
#ifdef UNIX
  long tot_time=0;
  struct timeval tv1,tv2;
  gettimeofday(&tv1,NULL);
#endif
  txt=calloc(MAXID,1);
  initializelist();
  yyin=fopen(argv[1],"r");
  if (!yyin)
  {
    fprintf(stderr,"Cannot open input file.\nExiting\n");
    return 1;
  }
  setvbuf(yyin,NULL,_IOFBF,BUFFERSIZE);
  outf=fopen(argv[2],"w");
  if (!outf)
  {
    fprintf(stderr,"Cannot create output file.\nExiting\n");
    return 1;
  }
  setvbuf(outf,NULL,_IOFBF,BUFFERSIZE);
  yyparse();
  fclose(yyin);
  fclose(outf);
#ifdef MSDOS
  gettime(&czas);
  printf("Stop  obliczen: %i : %i : %i : %i \n",czas.ti_hour, czas.ti_min, czas.ti_sec,czas.ti_hund);
#endif
#ifdef UNIX
  gettimeofday(&tv2,NULL);
  tot_time=(tv2.tv_sec*1000000+tv2.tv_usec)-(tv1.tv_sec*1000000+tv1.tv_usec);
  printf("Czas obliczen: %ld us",tot_time);
#endif
  return 0;
}

