%{
  /*
     Skrypt analizy leksykalnej dla potrzeb konwertera z
     rwna boolowskich na posta odwrotnej notacji polskiej
  Pawe Muszyski 2000
  */
#include <stdio.h>
#include <string.h>
#ifdef MSDOS
#include "gram_tab.h"
#endif
#ifdef UNIX
#include "gram.tab.h"
#endif
#include "list.h"
int pos=0;
%}
%option noyywrap
%x comment
%x longid
IDENT	[a-zA-Z_][a-zA-Z0-9_]*
NUMBER	[-0-9][0-9]*|"t-1"|"t"
ANYTH   [-a-zA-Z0-9_,]*
BACK	"\\"
MINUS	"--"
EMPTY	[ \t]
NEWL	"\n"

%%

<INITIAL>{BACK}		{strcpy(txt+pos,yytext);pos+=strlen(yytext);BEGIN(longid);}
<longid>{BACK}		{strcpy(txt+pos,yytext);strcpy(txt+strlen(txt)," \0");addtolist(txt);pos=0;BEGIN(INITIAL);return ID;}
<longid>{BACK}"("{ANYTH}")"	{strcpy(txt+pos,yytext);strcpy(txt+strlen(txt)," \0");addtolist(txt);pos=0;BEGIN(INITIAL);return ID;}
<longid>{BACK}{2}    	{strcpy(txt+pos,yytext);pos+=strlen(yytext);}
<longid>.		{strcpy(txt+pos,yytext);pos+=strlen(yytext);}
<INITIAL>"&"		{return AND;}
<INITIAL>"|"		{return OR;}
<INITIAL>"!"            {return NOT;}
<INITIAL>{IDENT}     	{strcpy(txt,yytext);strcpy(txt+strlen(txt)," \0");addtolist(txt);return ID;}
<INITIAL>{IDENT}"("{ANYTH}")"	{strcpy(txt,yytext);strcpy(txt+strlen(txt)," \0");addtolist(txt);return ID;}
<INITIAL>"("  		{return('(');}
<INITIAL>")"  		{return(')');}
<INITIAL>"="		{return(EQ);}
<INITIAL>";"		{return(SEMICOL);}
<INITIAL>{NUMBER}	{addtolist(yytext);return INT_EXPR;}
  /*<INITIAL>","		{return COMMA;}*/
<INITIAL>{EMPTY}
<INITIAL>"{"		{return('{');}
<INITIAL>"}"		{return('}');}
<INITIAL>{NEWL}		{linenum++;}


  /* komentarz*/
<INITIAL>{MINUS}	{strcpy(txt,yytext);BEGIN(comment);}
<comment>.*"\n"		{strcpy(txt+2,yytext);addtolist(txt);BEGIN(INITIAL);linenum++;return COMMENT;}

. {printf("ERROR -illegal character in line %d\n",linenum);exit(1);}
%%

