%{
  /*
     Skrypt analizy leksykalnej dla potrzeb konwertera z
     odwrotnej notacji polskiej na posta rwna boolowskich
  Pawe Muszyski 2000
  */
FILE *out;
#include <stdio.h>
#include <string.h>
#include <dos.h>
#include "list.h"
#include "klasy.h"
#include "stos.h"
Node *tmp;
Node *opleft, *opright;
char txt[32000];
int pos=0;
%}
%option noyywrap
%x comment
%x longid
IDENT	[a-zA-Z_][a-zA-Z0-9_]*
NUMBER	[-0-9][0-9]*|"t-1"|"t"
ANYTH   [-a-zA-Z0-9_,]*
BACK	"\\"
MINUS	"--"
EMPTY	[ \t]
NEWL	"\n"
ENDF	"<<EOF>>"

%%

<INITIAL>{BACK}			{strcpy(txt+pos,yytext);pos+=strlen(yytext);BEGIN(longid);}
<longid>{BACK}			{strcpy(txt+pos,yytext);addtolist(txt);pos=0;BEGIN(INITIAL);tmp = new Node; tmp->Value = 1; st.push(tmp);}
<longid>{BACK}"("{ANYTH}")"	{strcpy(txt+pos,yytext);addtolist(txt);pos=0;BEGIN(INITIAL);tmp = new Node; tmp->Value = 1; st.push(tmp);}
<longid>{BACK}" ="		{strcpy(txt+pos,yytext);fprintf(out,"%s",txt);BEGIN(INITIAL);pos=0;}
<longid>{BACK}"("{ANYTH}") ="	{strcpy(txt+pos,yytext);fprintf(out,"%s",txt);BEGIN(INITIAL);pos=0;}
<longid>{BACK}{2}    		{strcpy(txt+pos,yytext);pos+=strlen(yytext);}
<longid>.			{strcpy(txt+pos,yytext);pos+=strlen(yytext);}
<INITIAL>"&"			{opright = st.pop(); opleft = st.pop(); tmp = new Node; tmp->Value ='&'; tmp->Left = opleft; tmp-> Right = opright; tmp->AddPar(); st.push(tmp);}  /*stworz wezel OPER, pobierz 2 wezly ze stosu - lewe i prawe poddrzewo, nowy wezel na stos, opatulony w nawiasy*/
<INITIAL>"|"			{opright = st.pop(); opleft = st.pop(); tmp = new Node; tmp->Value ='|'; tmp->Left = opleft; tmp-> Right = opright; tmp->AddPar(); st.push(tmp);}  /*jw*/
<INITIAL>"!"            	{tmp = st.pop(); tmp-> Negated = !(tmp->Negated);st.push(tmp);}  /*Pobierz wezel ze stosu i ustaw mu negacje, potem na stos go*/
<INITIAL>{IDENT}     		{addtolist(yytext);tmp = new Node; tmp->Value = 1; st.push(tmp);}
<INITIAL>{IDENT}"("{ANYTH}")"	{addtolist(yytext);tmp = new Node; tmp->Value = 1; st.push(tmp);}
<INITIAL>{IDENT}" ="		{fprintf(out,"%s",yytext);}
<INITIAL>{IDENT}"("{ANYTH}") =" {fprintf(out,"%s",yytext);}
<INITIAL>";"			{tmp = st.pop(); tmp->RemovePar(); tmp->ProcessNode(out); delete tmp; fprintf(out, ";");}
<INITIAL>{NUMBER}		{addtolist(yytext);tmp = new Node; tmp->Value = 1; st.push(tmp);}
<INITIAL>{EMPTY}
<INITIAL>"{"			{fprintf(out, "{");}
<INITIAL>"}"			{fprintf(out, "}");}
<INITIAL>{NEWL}			{fprintf(out, "\n");}
{ENDF}				{return 0;}

  /* komentarz*/
<INITIAL>{MINUS}	{strcpy(txt,yytext);BEGIN(comment);}
<comment>.*"\n"		{strcpy(txt+2,yytext);fprintf(out, "%s", txt);BEGIN(INITIAL);}

. 			{printf("ERROR -illegal character %s",yytext);exit(1);}
%%

int main(int argc, char ** argv)
{
  struct time czas;
  gettime(&czas);
  printf("Start obliczen: %i : %i : %i : %i \n",czas.ti_hour, czas.ti_min, czas.ti_sec,czas.ti_hund);
  yyin = fopen(argv[1], "r");
  if (!yyin)
  {
    fprintf(stderr,"Error opening input file.\nExiting\n");
    exit(1);
  }
  out  = fopen(argv[2], "w");
  if (!out)
  {
    fprintf(stderr,"Error creating output file.\nExiting\n");
    exit(1);
  }
  yylex();
  fcloseall();
  gettime(&czas);
  printf("Stop  obliczen: %i : %i : %i : %i \n",czas.ti_hour, czas.ti_min, czas.ti_sec,czas.ti_hund);
  return 0;
}
